Index: palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 4225)
+++ palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 4226)
@@ -5269,6 +4716,5 @@
 !> Get dimension array for a given dimension
 !------------------------------------------------------------------------------!
-     SUBROUTINE netcdf_data_input_get_dimension_length( id, dim_len,           &
-                                                        variable_name )
+     SUBROUTINE get_dimension_length( id, dim_len, variable_name )
        USE pegrid
 
@@ -5286,14 +4732,12 @@
 !--    First, inquire dimension ID
        nc_stat = NF90_INQ_DIMID( id, TRIM( variable_name ), id_dim )
-       CALL handle_error( 'netcdf_data_input_get_dimension_length', 526,       &
-                          variable_name )
+       CALL handle_error( 'get_dimension_length', 526, variable_name )
 !
 !--    Inquire dimension length
        nc_stat = NF90_INQUIRE_DIMENSION( id, id_dim, dum, LEN = dim_len )
-       CALL handle_error( 'netcdf_data_input_get_dimension_length', 526,       &
-                          variable_name )
+       CALL handle_error( 'get_dimension_length', 526, variable_name )
 
 #endif
-    END SUBROUTINE netcdf_data_input_get_dimension_length
+    END SUBROUTINE get_dimension_length
 
 !------------------------------------------------------------------------------!
Index: palm/trunk/SOURCE/plant_canopy_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4225)
+++ palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4226)
@@ -22,9 +22,12 @@
 ! Current revisions:
 ! ------------------
-! Bugfix, missing initialization of heating rate
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Bugfix, missing initialization of heating rate
+! 
+! 4221 2019-09-09 08:50:35Z suehring
 ! Further bugfix in 3d data output for plant canopy
 ! 
Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4225)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4226)
@@ -28,4 +28,8 @@
 ! -----------------
 ! $Id$
+! - Netcdf input routine for dimension length renamed
+! - Define time variable for external radiation input relative to time_utc_init 
+! 
+! 4210 2019-09-02 13:07:09Z suehring
 ! - Revise steering of splitting diffuse and direct radiation
 ! - Bugfixes in checks
@@ -34,5 +38,6 @@
 ! 
 ! 4208 2019-09-02 09:01:07Z suehring
-! Bugfix in accessing albedo_pars in the clear-sky branch (merge from branch) 
+! Bugfix in accessing albedo_pars in the clear-sky branch
+! (merge from branch resler) 
 ! 
 ! 4198 2019-08-29 15:17:48Z gronemeier
@@ -259,4 +264,5 @@
                close_input_file,                                               &
                get_attribute,                                                  &
+               get_dimension_length,                                           &
                get_variable,                                                   &
                inquire_num_variables,                                          &
@@ -264,5 +270,4 @@
                input_file_dynamic,                                             &
                input_pids_dynamic,                                             &
-               netcdf_data_input_get_dimension_length,                         &
                num_var_pids,                                                   &
                pids_id,                                                        &
@@ -2510,7 +2515,5 @@
 !--       Input time dimension.
           IF ( check_existence( vars_pids, 'time_rad' ) )  THEN
-             CALL netcdf_data_input_get_dimension_length( pids_id,             &
-                                                          ntime,               &
-                                                          'time_rad' )
+             CALL get_dimension_length( pids_id, ntime, 'time_rad' )
           
              ALLOCATE( time_rad_f%var1d(0:ntime-1) )
@@ -2637,11 +2640,12 @@
           ENDIF
           
-          IF ( time_rad_f%var1d(0) /= 0.0_wp )  THEN
+          IF ( time_rad_f%var1d(0) /= time_utc_init )  THEN
              message_string = 'External radiation forcing: first point in ' // &
-                              'time is /= 0.0.'
+                              'time is /= time_utc_init.'
              CALL message( 'radiation_init', 'PA0313', 1, 2, 0, 6, 0 )
           ENDIF
           
-          IF ( end_time - spinup_time > time_rad_f%var1d(ntime-1) )  THEN
+          IF ( end_time - spinup_time > time_rad_f%var1d(ntime-1)              &
+                                      - time_utc_init )  THEN
              message_string = 'External radiation forcing does not cover ' //  &
                               'the entire simulation time.'
@@ -2832,5 +2836,6 @@
        ELSE
           t = 0
-          DO WHILE ( time_rad_f%var1d(t) <= time_since_reference_point )
+          DO WHILE ( time_rad_f%var1d(t) <=                                    &
+                     time_since_reference_point + time_utc_init )
              t = t + 1
           ENDDO
@@ -2838,5 +2843,6 @@
           tm = MAX( t-1, 0 )
           
-          fac_dt = ( time_since_reference_point - time_rad_f%var1d(tm) + dt_3d ) &
+          fac_dt = ( time_since_reference_point + time_utc_init                &
+                   - time_rad_f%var1d(tm) + dt_3d )                            &
                  / ( time_rad_f%var1d(t)  - time_rad_f%var1d(tm) )
           fac_dt = MIN( 1.0_wp, fac_dt )
Index: palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- palm/trunk/SOURCE/salsa_mod.f90	(revision 4225)
+++ palm/trunk/SOURCE/salsa_mod.f90	(revision 4226)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Netcdf input routine for dimension length renamed
+! 
+! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
 ! 
@@ -1757,7 +1760,8 @@
 
     USE netcdf_data_input_mod,                                                                     &
-        ONLY:  check_existence, close_input_file, get_attribute, get_variable,                     &
+        ONLY:  check_existence, close_input_file, get_dimension_length,                            &
+               get_attribute, get_variable,                                                        &
                inquire_num_variables, inquire_variable_names,                                      &
-               netcdf_data_input_get_dimension_length, open_read_file
+               open_read_file
 
     IMPLICIT NONE
@@ -1836,5 +1840,5 @@
 !
 !--       Inquire vertical dimension and number of aerosol chemical components
-          CALL netcdf_data_input_get_dimension_length( id_dyn, pr_nz, 'z' )
+          CALL get_dimension_length( id_dyn, pr_nz, 'z' )
           IF ( pr_nz /= nz )  THEN
              WRITE( message_string, * ) 'Number of inifor horizontal grid points does not match '//&
@@ -1842,5 +1846,5 @@
              CALL message( 'aerosol_init', 'PA0601', 1, 2, 0, 6, 0 )
           ENDIF
-          CALL netcdf_data_input_get_dimension_length( id_dyn, pr_ncc, 'composition_index' )
+          CALL get_dimension_length( id_dyn, pr_ncc, 'composition_index' )
 !
 !--       Allocate memory
@@ -1915,5 +1919,5 @@
 !
 !--          Bin mean diameters in the input file
-             CALL netcdf_data_input_get_dimension_length( id_dyn, pr_nbins, 'Dmid')
+             CALL get_dimension_length( id_dyn, pr_nbins, 'Dmid')
              IF ( pr_nbins /= nbins_aerosol )  THEN
                 message_string = 'Number of size bins in init_atmosphere_aerosol does not match '  &
@@ -2067,5 +2071,5 @@
 !
 !--       Inquire dimensions:
-          CALL netcdf_data_input_get_dimension_length( id_dyn, pr_nz, 'z' )
+          CALL get_dimension_length( id_dyn, pr_nz, 'z' )
           IF ( pr_nz /= nz )  THEN
              WRITE( message_string, * ) 'Number of inifor horizontal grid points does not match '//&
@@ -8388,5 +8392,5 @@
         ONLY:  check_existence, close_input_file, get_attribute, get_variable,                     &
                inquire_num_variables, inquire_variable_names,                                      &
-               netcdf_data_input_get_dimension_length, open_read_file, street_type_f
+               get_dimension_length, open_read_file, street_type_f
 
     USE surface_mod,                                                                               &
@@ -8525,5 +8529,5 @@
 !
 !--          Read the index and name of chemical components
-             CALL netcdf_data_input_get_dimension_length( id_salsa, aero_emission_att%ncc,         &
+             CALL get_dimension_length( id_salsa, aero_emission_att%ncc,         &
                                                           'composition_index' )
              ALLOCATE( aero_emission_att%cc_index(1:aero_emission_att%ncc) )
@@ -8598,6 +8602,5 @@
 !
 !--             Get number of emission categories and allocate emission arrays
-                CALL netcdf_data_input_get_dimension_length( id_salsa, aero_emission_att%ncat,     &
-                                                             'ncat' )
+                CALL get_dimension_length( id_salsa, aero_emission_att%ncat, 'ncat' )
                 ALLOCATE( aero_emission_att%cat_index(1:aero_emission_att%ncat),                   &
                           aero_emission_att%rho(1:aero_emission_att%ncat),                         &
@@ -8636,6 +8639,6 @@
 !--             For each hour of year:
                 IF ( check_existence( aero_emission_att%var_names, 'nhoursyear' ) )  THEN
-                   CALL netcdf_data_input_get_dimension_length( id_salsa,                          &
-                                                        aero_emission_att%nhoursyear, 'nhoursyear' )
+                   CALL get_dimension_length( id_salsa,                                            &
+                                              aero_emission_att%nhoursyear, 'nhoursyear' )
                    ALLOCATE( aero_emission_att%etf(1:aero_emission_att%ncat,                       &
                                                    1:aero_emission_att%nhoursyear) )
@@ -8645,7 +8648,7 @@
 !--             Based on the month, day and hour:
                 ELSEIF ( check_existence( aero_emission_att%var_names, 'nmonthdayhour' ) )  THEN
-                   CALL netcdf_data_input_get_dimension_length( id_salsa,                          &
-                                                                aero_emission_att%nmonthdayhour,   &
-                                                                'nmonthdayhour' )
+                   CALL get_dimension_length( id_salsa,                                            &
+                                              aero_emission_att%nmonthdayhour,                     &
+                                              'nmonthdayhour' )
                    ALLOCATE( aero_emission_att%etf(1:aero_emission_att%ncat,                       &
                                                    1:aero_emission_att%nmonthdayhour) )
@@ -8734,6 +8737,5 @@
 !
 !--             Number of aerosol size bins in the emission data
-                CALL netcdf_data_input_get_dimension_length( id_salsa, aero_emission_att%nbins,    &
-                                                             'Dmid' )
+                CALL get_dimension_length( id_salsa, aero_emission_att%nbins, 'Dmid' )
                 IF ( aero_emission_att%nbins /= nbins_aerosol )  THEN
                    message_string = 'The number of size bins in aerosol input data does not ' //   &
@@ -8743,5 +8745,5 @@
 !
 !--             Number of time steps in the emission data
-                CALL netcdf_data_input_get_dimension_length( id_salsa, aero_emission_att%nt, 'time')
+                CALL get_dimension_length( id_salsa, aero_emission_att%nt, 'time')
 !
 !--             Allocate bin diameters, time and mass fraction array
@@ -9124,5 +9126,5 @@
         ONLY:  check_existence, close_input_file, get_attribute, get_variable,                     &
                inquire_num_variables, inquire_variable_names,                                      &
-               netcdf_data_input_get_dimension_length, open_read_file
+               get_dimension_length, open_read_file
 
     USE surface_mod,                                                                               &
@@ -9174,6 +9176,5 @@
 !
 !--    Read the index and name of chemical components
-       CALL netcdf_data_input_get_dimension_length( id_chem, chem_emission_att%n_emiss_species,    &
-                                                    'nspecies' )
+       CALL get_dimension_length( id_chem, chem_emission_att%n_emiss_species, 'nspecies' )
        ALLOCATE( chem_emission_att%species_index(1:chem_emission_att%n_emiss_species) )
        CALL get_variable( id_chem, 'emission_index', chem_emission_att%species_index )
@@ -9221,5 +9222,5 @@
 !
 !--       Get number of emission categories and allocate emission arrays
-          CALL netcdf_data_input_get_dimension_length( id_chem, chem_emission_att%ncat, 'ncat' )
+          CALL get_dimension_length( id_chem, chem_emission_att%ncat, 'ncat' )
           ALLOCATE( chem_emission_att%cat_index(1:chem_emission_att%ncat),                         &
                     time_factor(1:chem_emission_att%ncat) )
@@ -9235,6 +9236,5 @@
 !--       For each hour of year:
           IF ( check_existence( var_names, 'nhoursyear' ) )  THEN
-             CALL netcdf_data_input_get_dimension_length( id_chem, chem_emission_att%nhoursyear,   &
-                                                          'nhoursyear' )
+             CALL get_dimension_length( id_chem, chem_emission_att%nhoursyear, 'nhoursyear' )
              ALLOCATE( chem_emission_att%hourly_emis_time_factor(1:chem_emission_att%ncat,         &
                                                                  1:chem_emission_att%nhoursyear) )
@@ -9245,6 +9245,5 @@
 !--       Based on the month, day and hour:
           ELSEIF ( check_existence( var_names, 'nmonthdayhour' ) )  THEN
-             CALL netcdf_data_input_get_dimension_length( id_chem, chem_emission_att%nmonthdayhour,&
-                                                          'nmonthdayhour' )
+             CALL get_dimension_length( id_chem, chem_emission_att%nmonthdayhour, 'nmonthdayhour' )
              ALLOCATE( chem_emission_att%mdh_emis_time_factor(1:chem_emission_att%ncat,            &
                                                               1:chem_emission_att%nmonthdayhour) )
@@ -9284,6 +9283,5 @@
 !
 !--       Number of time steps in the emission data
-          CALL netcdf_data_input_get_dimension_length( id_chem, chem_emission_att%dt_emission,     &
-                                                       'time' )
+          CALL get_dimension_length( id_chem, chem_emission_att%dt_emission, 'time' )
 !
 !--       Allocate and read time
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 4225)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 4226)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Changes in interface for the offline nesting
+! 
+! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
 ! 
@@ -257,8 +260,12 @@
 
     USE nesting_offl_mod,                                                                          &
-        ONLY:  nesting_offl_bc, nesting_offl_mass_conservation
+        ONLY:  nesting_offl_bc,                                                                    &
+               nesting_offl_geostrophic_wind,                                                      &
+               nesting_offl_input,                                                                 &
+               nesting_offl_interpolation_factor,                                                  &
+               nesting_offl_mass_conservation
 
     USE netcdf_data_input_mod,                                                                     &
-        ONLY:  chem_emis, chem_emis_att, nest_offl, netcdf_data_input_offline_nesting
+        ONLY:  chem_emis, chem_emis_att
 
     USE ocean_mod,                                                                                 &
@@ -566,11 +573,6 @@
        ENDIF
 !
-!--    If forcing by larger-scale models is applied, check if new data
-!--    at domain boundaries need to be read.
-       IF ( nesting_offline ) THEN
-          IF ( nest_offl%time(nest_offl%tind_p) <= time_since_reference_point ) &
-               CALL netcdf_data_input_offline_nesting
-       ENDIF
-
+!--    Input of boundary data. 
+       IF ( nesting_offline )  CALL nesting_offl_input
 !
 !--    Execute all other module actions routunes
@@ -955,8 +957,13 @@
 !
 !--       Map forcing data derived from larger scale model onto domain 
-!--       boundaries. 
+!--       boundaries. Further, update geostrophic wind components.
           IF ( nesting_offline  .AND.  intermediate_timestep_count ==                              &
-                                       intermediate_timestep_count_max  )                          &
+                                       intermediate_timestep_count_max  )  THEN
+!--          Determine interpolation factor before boundary conditions and geostrophic wind 
+!--          is updated.
+             CALL nesting_offl_interpolation_factor
              CALL nesting_offl_bc
+             CALL nesting_offl_geostrophic_wind
+          ENDIF
 !
 !--       Impose a turbulent inflow using synthetic generated turbulence.
Index: palm/trunk/SOURCE/virtual_measurement_mod.f90
===================================================================
--- palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4225)
+++ palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4226)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Netcdf input routine for dimension length renamed
+! 
+! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
 ! 
@@ -435,7 +438,9 @@
  
     USE netcdf_data_input_mod,                                                 &
-        ONLY:  init_model, input_file_vm,                                      &
-               netcdf_data_input_get_dimension_length,                         &
-               netcdf_data_input_att, netcdf_data_input_var
+        ONLY:  get_dimension_length,                                           &
+               init_model,                                                     &
+               input_file_vm,                                                  &
+               netcdf_data_input_att,                                          &
+               netcdf_data_input_var
         
     IMPLICIT NONE
@@ -648,12 +653,12 @@
 !--          For non-stationary measurements read the number of trajectories
 !--          and the number of time coordinates.
-             CALL netcdf_data_input_get_dimension_length( vmea_general%id_vm, &
-                                                          vmea(l)%ntraj,      &
-                                                          "traj" //           &
-                                                          TRIM( dum ) )
-             CALL netcdf_data_input_get_dimension_length( vmea_general%id_vm, &
-                                                          dim_ntime,          &
-                                                          "ntime" //          &
-                                                          TRIM( dum ) )
+             CALL get_dimension_length( vmea_general%id_vm,                    &
+                                        vmea(l)%ntraj,                         &
+                                        "traj" //                              &
+                                        TRIM( dum ) )
+             CALL get_dimension_length( vmea_general%id_vm,                    &
+                                        dim_ntime,                             &
+                                        "ntime" //                             &
+                                        TRIM( dum ) )
 !
 !--       For stationary measurements the dimension for UTM and time 
